Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 4494)
+++ palm/trunk/SOURCE/palm.f90	(revision 4495)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! restart data handling with MPI-IO added
+! 
+! 4457 2020-03-11 14:20:43Z raasch
 ! use statement for exchange horiz added
 ! 
@@ -86,5 +89,5 @@
     USE control_parameters,                                                    &
         ONLY:  coupling_char, do2d_at_begin, do3d_at_begin, io_blocks,         &
-               io_group, message_string, runnr, simulated_time_chr, spinup,    &
+               io_group, message_string, restart_data_format_output, runnr, simulated_time_chr, spinup,   &
                time_since_reference_point, user_interface_current_revision,    &
                user_interface_required_revision, version, write_binary
@@ -140,4 +143,7 @@
                pmci_modelconfiguration, pmci_parent_initialize
 #endif
+
+    USE restart_data_mpi_io_mod,                                               &
+        ONLY:  rd_mpi_io_close, rd_mpi_io_open
 
     USE surface_data_output_mod,                                               &
@@ -168,5 +174,5 @@
 
     version = 'PALM 6.0'
-    user_interface_required_revision = 'r3703'
+    user_interface_required_revision = 'r4495'
 
 #if defined( __parallel )
@@ -399,25 +405,43 @@
        CALL location_message( 'writing restart data', 'start' )
 
-       DO  i = 0, io_blocks-1
-          IF ( i == io_group )  THEN
-
-!
-!--          Open binary file 
-             CALL check_open( 14 )
-!
-!--          Write control parameters and other global variables for restart.
-             IF ( myid == 0 )  CALL wrd_global
-!
-!--          Write processor specific flow field data for restart runs
-             CALL wrd_local
-!
-!--          Close binary file 
-             CALL close_file( 14 )
-
-          ENDIF
-#if defined( __parallel )
-          CALL MPI_BARRIER( comm2d, ierr )
-#endif
-       ENDDO
+       IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+          DO  i = 0, io_blocks-1
+             IF ( i == io_group )  THEN
+
+!
+!--             Open binary file
+                CALL check_open( 14 )
+!
+!--             Write control parameters and other global variables for restart.
+                IF ( myid == 0 )  CALL wrd_global
+!
+!--             Write processor specific flow field data for restart runs
+                CALL wrd_local
+!
+!--             Close binary file
+                CALL close_file( 14 )
+
+             ENDIF
+#if defined( __parallel )
+             CALL MPI_BARRIER( comm2d, ierr )
+#endif
+          ENDDO
+
+       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+!
+!--       Open MPI-IO restart file
+          CALL rd_mpi_io_open( 'write', 'BINOUT' )
+!
+!--       Write control parameters and other global variables for restart.
+          CALL wrd_global
+!
+!--       Write processor specific flow field data for restart runs
+          CALL wrd_local
+!
+!--       Close restart File
+          CALL rd_mpi_io_close
+
+       ENDIF
 
        CALL location_message( 'writing restart data', 'finished' )
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 4494)
+++ palm/trunk/SOURCE/parin.f90	(revision 4495)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! restart data handling with MPI-IO added
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! removed recycling_yshift
 ! 
@@ -267,4 +270,5 @@
              recycling_method_for_thermodynamic_quantities, recycling_width,   &
              reference_state, residual_limit,                                  &
+             restart_data_format, restart_data_format_input, restart_data_format_output,           &
              rotation_angle,                                                   &
              roughness_length, scalar_advec,                                   &
@@ -337,4 +341,5 @@
              profile_columns, profile_rows,     &
              restart_time, section_xy, section_xz, section_yz,                 &
+             restart_data_format, restart_data_format_input, restart_data_format_output,           &
              skip_time_data_output, skip_time_data_output_av, skip_time_dopr,  &
              skip_time_do2d_xy, skip_time_do2d_xz, skip_time_do2d_yz,          &
@@ -499,4 +504,16 @@
           IF ( TRIM( initializing_actions ) == 'read_restart_data' )  THEN
 
+!
+!--          If not set by the user in the runtime parameters, the data format for restart
+!--          input needs to be set now! This is normally done later in check parameters.
+             IF ( TRIM( restart_data_format ) /= 'fortran_binary'  .AND.                           &
+                  TRIM( restart_data_format ) /= 'mpi' )  THEN
+                message_string = 'illegal restart data format "' // TRIM( restart_data_format ) // '"'
+                CALL message( 'parin', 'PA....', 1, 2, 0, 6, 0 )
+             ENDIF
+             IF ( TRIM( restart_data_format_input ) == 'undefined' )  THEN
+                restart_data_format_input = restart_data_format
+             ENDIF
+
              CALL rrd_global
 !
Index: palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4494)
+++ palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4495)
@@ -26,9 +26,10 @@
 ! Former revisions:
 ! -----------------
+! $Id$
+! restart data handling with MPI-IO added
+!
+! 4457 2020-03-11 14:20:43Z raasch
 !
 ! use statement for exchange horiz added
-! 
-! 
-! $Id$
 ! (salim) removed the error message PA0672 to consider PC 3d data via ascii file
 !
@@ -191,4 +192,5 @@
               passive_scalar,                                                  &
               plant_canopy,                                                    &
+              restart_data_format_output,                                      &
               restart_string,                                                  &
               urban_surface
@@ -221,4 +223,7 @@
 
     USE pegrid
+
+    USE restart_data_mpi_io_mod,                                                                   &
+        ONLY:  wrd_mpi_io
 
     USE surface_mod,                                                           &
@@ -2436,19 +2441,33 @@
     SUBROUTINE pcm_wrd_local
 
-       IF ( ALLOCATED( pcm_heatrate_av ) )  THEN
-          CALL wrd_write_string( 'pcm_heatrate_av' )
-          WRITE ( 14 )  pcm_heatrate_av
+       IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+          IF ( ALLOCATED( pcm_heatrate_av ) )  THEN
+             CALL wrd_write_string( 'pcm_heatrate_av' )
+             WRITE ( 14 )  pcm_heatrate_av
+          ENDIF
+
+          IF ( ALLOCATED( pcm_latentrate_av ) )  THEN
+             CALL wrd_write_string( 'pcm_latentrate_av' )
+             WRITE ( 14 )  pcm_latentrate_av
+          ENDIF
+
+          IF ( ALLOCATED( pcm_transpirationrate_av ) )  THEN
+             CALL wrd_write_string( 'pcm_transpirationrate_av' )
+             WRITE ( 14 )  pcm_transpirationrate_av
+          ENDIF
+
+       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+          IF ( ALLOCATED( pcm_heatrate_av ) )  CALL wrd_mpi_io( 'pcm_heatrate_av', pcm_heatrate_av )
+          IF ( ALLOCATED( pcm_latentrate_av ) )  THEN
+             CALL wrd_mpi_io( 'pcm_latentrate_av', pcm_latentrate_av )
+          ENDIF
+          IF ( ALLOCATED( pcm_transpirationrate_av ) )  THEN
+             CALL wrd_write_string( 'pcm_transpirationrate_av', pcm_transpirationrate_av )
+          ENDIF
+
        ENDIF
 
-       IF ( ALLOCATED( pcm_latentrate_av ) )  THEN
-          CALL wrd_write_string( 'pcm_latentrate_av' )
-          WRITE ( 14 )  pcm_latentrate_av
-       ENDIF
-
-       IF ( ALLOCATED( pcm_transpirationrate_av ) )  THEN
-          CALL wrd_write_string( 'pcm_transpirationrate_av' )
-          WRITE ( 14 )  pcm_transpirationrate_av
-       ENDIF
-
     END SUBROUTINE pcm_wrd_local
 
Index: palm/trunk/SOURCE/posix_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/posix_interface_mod.f90	(revision 4495)
+++ palm/trunk/SOURCE/posix_interface_mod.f90	(revision 4495)
@@ -0,0 +1,611 @@
+!> @file posix_interface_mod.f90
+!------------------------------------------------------------------------------!
+! This file is part of the PALM model system.
+!
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
+!
+! Copyright 1997-2020 Leibniz Universitaet Hannover
+! -------------------------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+! Initial version (K. Ketelsen)
+!
+! 
+!
+! Description:
+! ------------
+!> Interface to some POSIX system calls, mainly used for read/write of restart files
+!> in non-parallel mode in MPI-IO compatible format.
+!--------------------------------------------------------------------------------------------------!
+ MODULE posix_interface
+
+    USE ISO_C_BINDING
+
+    USE kinds
+
+    IMPLICIT NONE
+
+    PRIVATE
+
+    SAVE
+
+!
+!-- Definitions copied from C include file fcntl.h
+    INTEGER, PARAMETER ::  O_RDONLY =  0
+    INTEGER, PARAMETER ::  O_WRONLY =  1
+    INTEGER, PARAMETER ::  O_RDWR   =  2
+    INTEGER, PARAMETER ::  O_CREAT  = 64  !> 0100 octal
+    INTEGER, PARAMETER ::  SEEK_SET =  0
+
+
+!
+!-- Interfaces for POSIX calls
+    INTERFACE
+       INTEGER(C_INT)  FUNCTION C_OPEN( pathname, flags, mode )  BIND( C, NAME = 'open' )
+          USE ISO_C_BINDING
+          IMPLICIT NONE
+          CHARACTER(KIND=C_CHAR), DIMENSION(128) ::  pathname
+          INTEGER(KIND=C_INT), VALUE             ::  flags
+          INTEGER(KIND=C_INT), VALUE             ::  mode
+       END FUNCTION C_OPEN
+    END INTERFACE
+
+   INTERFACE
+      INTEGER(C_SIZE_T)  FUNCTION C_LSEEK( fd, offset, whence )  BIND( C, NAME = 'lseek' )
+         USE ISO_C_BINDING
+         IMPLICIT NONE
+         INTEGER(KIND=C_INT), VALUE              ::  fd
+         INTEGER(KIND=C_SIZE_T), VALUE           ::  offset
+         INTEGER(KIND=C_INT), VALUE              ::  whence
+      END FUNCTION C_LSEEK
+   END INTERFACE
+
+!
+!-- The read system call uses values of type off_t. There is no Fortran C_OFF_T, therefore  C_SIZE_T
+!-- has been used here, assuming both are 8 byte integers.
+    INTERFACE
+       INTEGER(C_SIZE_T)  FUNCTION C_READ( fd, buf, nr_byte )  BIND(C, NAME = 'read' )
+          USE ISO_C_BINDING
+          IMPLICIT NONE
+          INTEGER(KIND=C_INT), VALUE            ::  fd
+          TYPE(C_PTR), VALUE                    ::  buf
+          INTEGER(KIND=C_SIZE_T), VALUE         ::  nr_byte
+          END FUNCTION C_READ
+    END INTERFACE
+
+    INTERFACE
+       INTEGER(C_SIZE_T)  FUNCTION C_WRITE( fd, buf, nr_byte )  BIND( C, NAME = 'write' )
+          USE ISO_C_BINDING
+          IMPLICIT NONE
+          INTEGER(KIND=C_INT), VALUE            ::  fd
+          TYPE(C_PTR), VALUE                    ::  buf
+          INTEGER(KIND=C_SIZE_T), VALUE         ::  nr_byte
+       END FUNCTION C_WRITE
+    END INTERFACE
+
+    INTERFACE
+       INTEGER(C_INT)  FUNCTION C_CLOSE( fd )  BIND( C, NAME = 'close' )
+          USE ISO_C_BINDING
+          IMPLICIT NONE
+          INTEGER(KIND=C_INT), VALUE            ::  fd
+       END FUNCTION C_CLOSE
+    END INTERFACE
+
+!
+!-- PALM interfaces
+    INTERFACE posix_close
+       MODULE PROCEDURE posix_close
+    END INTERFACE posix_close
+
+    INTERFACE posix_lseek
+       MODULE PROCEDURE posix_lseek
+    END INTERFACE posix_lseek
+
+    INTERFACE posix_open
+       MODULE PROCEDURE posix_open
+    END INTERFACE posix_open
+
+    INTERFACE posix_read
+       MODULE PROCEDURE posix_read
+       MODULE PROCEDURE posix_read_char_array
+       MODULE PROCEDURE posix_read_int_1d
+       MODULE PROCEDURE posix_read_int_2d
+       MODULE PROCEDURE posix_read_offset_1d
+       MODULE PROCEDURE posix_read_real_1d
+       MODULE PROCEDURE posix_read_real_2d
+       MODULE PROCEDURE posix_read_real_3d
+    END INTERFACE posix_read
+
+    INTERFACE posix_write
+       MODULE PROCEDURE posix_write
+       MODULE PROCEDURE posix_write_char_array
+       MODULE PROCEDURE posix_write_int_1d
+       MODULE PROCEDURE posix_write_int_2d
+       MODULE PROCEDURE posix_write_offset_1d
+       MODULE PROCEDURE posix_write_real_1d
+       MODULE PROCEDURE posix_write_real_2d
+       MODULE PROCEDURE posix_write_real_3d
+    END INTERFACE posix_write
+
+    PUBLIC posix_close, posix_lseek, posix_open, posix_read, posix_write
+
+ CONTAINS
+
+ INTEGER FUNCTION posix_open( file_name, rd_flag )
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=*), INTENT(IN)            ::  file_name
+    CHARACTER(LEN=1), DIMENSION(:), POINTER ::  f_string
+    CHARACTER(LEN=128), TARGET              ::  lo_file_name
+
+    INTEGER(C_INT)                          ::  fd
+    INTEGER(C_INT)                          ::  flags
+    INTEGER(C_INT)                          ::  name_len
+    INTEGER(C_INT)                          ::  mode
+    INTEGER, DIMENSION(1)                   ::  bufshape
+
+    LOGICAL, INTENT(IN)                     ::  rd_flag
+
+    TYPE(C_PTR)                             ::  ptr
+
+
+!
+!-- Note: There might be better solutions to convert FORTRAN string to C string but this works on
+!-- different FORTRAN compiler
+    name_len     = LEN( TRIM( file_name ) ) + 1
+    lo_file_name = TRIM( file_name ) // CHAR(0)
+    ptr          = C_LOC( lo_file_name(1:1) )
+    bufshape(1)  = name_len
+    CALL C_F_POINTER( ptr, f_string, bufshape )
+
+    mode = 420  ! Mode 644
+
+    IF ( rd_flag )  THEN
+       flags = O_RDONLY
+       fd    = C_OPEN (f_string, flags, mode)  ! Open for reading
+    ELSE
+       flags = O_WRONLY + O_CREAT
+       fd    = C_OPEN (f_string, flags, mode)  ! Open for writing
+    ENDIF
+
+    posix_open = fd
+
+ END FUNCTION posix_open
+
+
+
+ SUBROUTINE posix_lseek( fid, offset )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)                ::  fid
+    INTEGER(KIND=C_INT)                ::  my_fid
+    INTEGER(KIND=C_SIZE_T), INTENT(IN) ::  offset
+    INTEGER(KIND=C_SIZE_T)             ::  retval
+    INTEGER(KIND=C_INT)                ::  whence
+
+
+    my_fid = fid
+    whence = SEEK_SET
+
+    retval = C_LSEEK( my_fid, offset, whence )
+
+ END SUBROUTINE posix_lseek
+
+
+
+ SUBROUTINE posix_read_int_1d( fid, data, nw )
+
+    IMPLICIT NONE
+
+    INTEGER(KIND=iwp), INTENT(IN), TARGET, DIMENSION(:) ::  data
+    INTEGER, INTENT(IN)                                 ::  fid
+    INTEGER                                             ::  nr_byte
+    INTEGER, INTENT(IN)                                 ::  nw
+
+    TYPE(C_PTR)                                         ::  buf
+
+
+    nr_byte = nw*iwp
+    buf     = C_LOC( data )
+
+    CALL posix_read( fid, buf, nr_byte )
+
+ END SUBROUTINE posix_read_int_1d
+
+
+
+ SUBROUTINE posix_read_int_2d (fid, data, nw)
+
+    IMPLICIT NONE
+
+    INTEGER(KIND=iwp), INTENT(IN), TARGET, DIMENSION(:,:) ::  data
+    INTEGER, INTENT(IN)                                   ::  fid
+    INTEGER                                               ::  nr_byte
+    INTEGER, INTENT(IN)                                   ::  nw
+
+    TYPE(C_PTR)                                           ::  buf
+
+
+    nr_byte = nw * iwp
+    buf     = C_LOC( data )
+
+    CALL posix_read( fid, buf, nr_byte )
+
+ END SUBROUTINE posix_read_int_2d
+
+
+
+ SUBROUTINE posix_read_offset_1d( fid, data, nw )
+
+    IMPLICIT NONE
+
+    INTEGER(KIND=C_SIZE_T), INTENT(IN), TARGET, DIMENSION(:) ::  data
+    INTEGER, INTENT(IN)                                      ::  fid
+    INTEGER                                                  ::  nr_byte
+    INTEGER, INTENT(IN)                                      ::  nw
+    TYPE(C_PTR)                                              ::  buf
+
+
+    nr_byte = nw * C_SIZE_T
+    buf     = C_LOC( data )
+
+    CALL posix_read( fid, buf, nr_byte )
+
+ END SUBROUTINE posix_read_offset_1d
+
+
+
+ SUBROUTINE posix_read_real_1d( fid, data, nw )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)                             ::  fid
+    INTEGER                                         ::  nr_byte
+    INTEGER, INTENT(IN)                             ::  nw
+
+    REAL(KIND=wp), INTENT(IN), TARGET, DIMENSION(:) ::  data
+
+    TYPE(C_PTR)                                     ::  buf
+
+
+    nr_byte = nw * wp
+    buf     = C_LOC( data )
+
+    CALL posix_read( fid, buf, nr_byte )
+
+ END SUBROUTINE posix_read_real_1d
+
+
+
+ SUBROUTINE posix_read_real_2d( fid, data, nw )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)                                  ::  fid
+    INTEGER                                              ::  nr_byte
+    INTEGER, INTENT(IN)                                  ::  nw
+
+    REAL(KIND=wp), INTENT(INOUT), TARGET, DIMENSION(:,:) ::  data
+
+    TYPE(C_PTR)                                          ::  buf
+
+
+    nr_byte = nw * wp
+    buf     = C_LOC( data )
+
+    CALL posix_read( fid, buf, nr_byte )
+
+ END SUBROUTINE posix_read_real_2d
+
+
+
+ SUBROUTINE posix_read_real_3d( fid, data, nw )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)                                    ::  fid
+    INTEGER                                                ::  nr_byte
+    INTEGER, INTENT(IN)                                    ::  nw
+
+    REAL(KIND=wp), INTENT(INOUT), TARGET, DIMENSION(:,:,:) ::  data
+
+    TYPE(C_PTR)                                            ::  buf
+
+
+    nr_byte = nw * wp
+    buf     = C_LOC( data )
+
+    CALL posix_read( fid, buf, nr_byte )
+
+ END SUBROUTINE posix_read_real_3d
+
+
+
+ SUBROUTINE posix_read( fid, buf, nb )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)    ::  fid
+    INTEGER(KIND=C_INT)    ::  my_fid
+    INTEGER , INTENT(IN)   ::  nb
+    INTEGER(KIND=C_SIZE_T) ::  nr_byte
+    INTEGER(KIND=C_SIZE_T) ::  retval
+
+    TYPE(C_PTR)            ::  buf
+
+
+    my_fid  = fid
+    nr_byte = nb
+
+    retval = C_READ( my_fid, buf, nr_byte )
+
+!
+!-- The posix standard says that is not guaranteed that all bytes are read in one read system call.
+!-- If retval is not equal to nr_byte, another system call has to be issued.
+!-- However, in all Unix distributions it is commonly accepted, that all bytes are read in one call
+!-- during during disk-IO. Therefore, here is only an error query and no reading in a while loop.
+    IF ( retval /= nr_byte )  THEN
+        WRITE(6,*) 'Number of bytes read does not match the number of requested bytes'
+        CALL abort
+    ENDIF
+
+ END SUBROUTINE posix_read
+
+
+
+ SUBROUTINE posix_read_char_array( fid, data )
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=*), DIMENSION(:)   ::  data
+    CHARACTER(LEN=LEN(data)), TARGET ::  data_buf
+
+    INTEGER, INTENT(IN)              ::  fid
+    INTEGER                          ::  i
+    INTEGER(KIND=C_INT)              ::  my_fid
+    INTEGER(KIND=C_SIZE_T)           ::  name_len
+    INTEGER(KIND=C_SIZE_T)           ::  retval
+
+    TYPE(C_PTR)                      ::  ptr
+
+
+    my_fid  = fid
+
+    DO  i = 1, SIZE( data )
+       data_buf = data(i)
+       name_len = LEN(data(i))
+       ptr      = C_LOC( data_buf(1:1) )
+       retval   = C_READ( my_fid, ptr, name_len )
+       data(i)  = data_buf
+    ENDDO
+
+ END SUBROUTINE posix_read_char_array
+
+
+
+ SUBROUTINE posix_write_int_1d( fid, data, nw )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)                                 ::  fid
+    INTEGER(KIND=C_INT)                                 ::  my_fid
+    INTEGER(KIND=C_SIZE_T)                              ::  nr_byte
+    INTEGER , INTENT(IN)                                ::  nw
+    INTEGER(KIND=C_SIZE_T)                              ::  retval
+
+    INTEGER(KIND=iwp), INTENT(IN), TARGET, DIMENSION(:) ::  data
+
+    TYPE(C_PTR)                                         ::  buf
+
+
+    my_fid  = fid
+    nr_byte = nw * iwp
+    buf     = C_LOC( data )
+
+    retval = C_WRITE( my_fid, buf, nr_byte )
+
+ END SUBROUTINE posix_write_int_1d
+
+
+
+ SUBROUTINE posix_write_int_2d( fid, data, nw )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)                                   ::  fid
+    INTEGER                                               ::  nr_byte
+    INTEGER, INTENT(IN)                                   ::  nw
+
+    INTEGER(KIND=iwp), INTENT(IN), TARGET, DIMENSION(:,:) ::  data
+
+    TYPE(C_PTR)                                           :: buf
+
+
+    nr_byte = nw * iwp
+    buf     = C_LOC( data )
+
+    CALL posix_write( fid, buf, nr_byte )
+
+ END SUBROUTINE posix_write_int_2d
+
+
+
+ SUBROUTINE posix_write_offset_1d( fid, data, nw )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)                                      ::  fid
+    INTEGER                                                  ::  nr_byte
+    INTEGER, INTENT(IN)                                      ::  nw
+
+    INTEGER(KIND=C_SIZE_T), INTENT(IN), TARGET, DIMENSION(:) ::  data
+
+    TYPE(C_PTR)                                              ::  buf
+
+
+    nr_byte = nw * STORAGE_SIZE( data(1) ) / 8
+    buf     = C_LOC( data )
+
+    CALL posix_write(fid, buf, nr_byte )
+
+ END SUBROUTINE posix_write_offset_1d
+
+
+
+ SUBROUTINE posix_write_real_1d( fid, data, nw )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)                             ::  fid
+    INTEGER                                         ::  nr_byte
+    INTEGER, INTENT(IN)                             ::  nw
+
+    REAL(KIND=wp), INTENT(IN), TARGET, DIMENSION(:) ::  data
+
+    TYPE(C_PTR)                                     ::  buf
+
+
+    nr_byte = nw * wp
+    buf     = C_LOC( data )
+
+    CALL posix_write( fid, buf, nr_byte )
+
+ END SUBROUTINE posix_write_real_1d
+
+
+
+ SUBROUTINE posix_write_real_2d( fid, data, nw )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)                                  ::  fid
+    INTEGER                                              ::  nr_byte
+    INTEGER, INTENT(IN)                                  ::  nw
+
+    REAL(KIND=wp), INTENT(INOUT), TARGET, DIMENSION(:,:) ::  data
+
+    TYPE(C_PTR)                                          ::  buf
+
+
+    nr_byte = nw * wp
+    buf     = C_LOC( data )
+
+    CALL posix_write( fid, buf, nr_byte )
+
+ END SUBROUTINE posix_write_real_2d
+
+
+
+ SUBROUTINE posix_write_real_3d( fid, data, nw )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)                                    ::  fid
+    INTEGER                                                ::  nr_byte
+    INTEGER, INTENT(IN)                                    ::  nw
+
+    REAL(KIND=wp), INTENT(INOUT), TARGET, DIMENSION(:,:,:) ::  data
+
+    TYPE(C_PTR)                                            ::  buf
+
+
+    nr_byte = nw * wp
+    buf     = C_LOC( data )
+
+    CALL posix_write( fid, buf, nr_byte )
+
+ END SUBROUTINE posix_write_real_3d
+
+
+
+ SUBROUTINE posix_write( fid, buf, nb )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)    ::  fid
+    INTEGER(KIND=C_INT)    ::  my_fid
+    INTEGER , INTENT(IN)   ::  nb
+    INTEGER(KIND=C_SIZE_T) ::  nr_byte
+    INTEGER(KIND=C_SIZE_T) ::  retval
+
+    TYPE(C_PTR)            ::  buf
+
+
+    my_fid  = fid
+    nr_byte = nb
+
+    retval = C_WRITE( my_fid, buf, nr_byte )
+
+    IF ( retval /= nr_byte )  THEN
+       WRITE(6,*) 'Number of bytes to write does not match the number of requested bytes'
+       CALL abort
+    ENDIF
+
+ END SUBROUTINE posix_write
+
+
+
+ SUBROUTINE posix_write_char_array( fid, data )
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=*), DIMENSION(:)     ::  data
+
+    CHARACTER(LEN=LEN(data)+1), TARGET ::  data_buf
+
+    INTEGER, INTENT(IN)                ::  fid
+    INTEGER                            ::  i
+    INTEGER(KIND=C_INT)                ::  my_fid
+    INTEGER(KIND=C_SIZE_T)             ::  name_len
+    INTEGER(KIND=C_SIZE_T)             ::  retval
+
+    TYPE(C_PTR)                        ::  ptr
+
+
+    my_fid  = fid
+
+    DO  i = 1, SIZE( data )
+       data_buf = data(i) // CHAR( 0 )
+       name_len = LEN( data(i) )
+       ptr      = C_LOC( data_buf(1:1) )
+       retval   = C_WRITE( my_fid, ptr, name_len )
+    ENDDO
+
+ END SUBROUTINE posix_write_char_array
+
+
+
+ SUBROUTINE posix_close( fid )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN) ::  fid
+    INTEGER(KIND=C_INT) ::  my_fid
+    INTEGER(KIND=C_INT) ::  retval
+
+
+    my_fid = fid
+
+    retval = C_CLOSE( my_fid )
+
+ END SUBROUTINE posix_close
+
+
+ END MODULE posix_interface
